// $Id: getctxproc.h,v 1.2 2004/01/09 01:01:55 ensc Exp $    --*- c++ -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifndef H_VSERVER_DJINNI_SRC_GETCTXPROC_H
#define H_VSERVER_DJINNI_SRC_GETCTXPROC_H

#include <stdbool.h>
#include <sys/types.h>

struct GetContextProcess
{
    int		fd_;		//< the communication socket
    int		sync_;		//< the synchronization socket; each client
				//< must read one byte before sending a
				//< request
    pid_t	pid_;		//< the pid of the get-context-process
};

  // Initializes the get-context-process by:
  // * creating a socketpair-pair
  // * creating a synchronization pipe
  // * forking a new process
  // * putting this new process in ctx 1
  /*@superuser@*/
bool	GetContextProcess_init(struct GetContextProcess * self) NONNULL(1);

  // Closes open filedescriptors; this function can be called from the
  // main-program only (or its children). When the last child calls this
  // function, the get-context-process will terminate also.
void	GetContextProcess_delete(struct GetContextProcess * self) NONNULL(1);

void	GetContextProcess_detach(struct GetContextProcess * self) NONNULL(1);

  // Returns the context-number of the process with pid
xid_t	GetContextProcess_getctx(struct GetContextProcess * self,
				 pid_t pid) NONNULL(1);

#endif	//  H_VSERVER_DJINNI_SRC_GETCTXPROC_H
