// $Id: logging.c,v 1.3 2003/11/22 00:16:52 ensc Exp $    --*- c -*--

// Copyright (C) 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de>
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//  
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//  
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.


#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "logging.h"
#include "wrappers.h"
#include "util-io.h"
#include "lib/fmt.h"

#if 0
static void
dupfd(char const *subdir, pid_t pid, int fd)
{
  mkdir(subdir, 0700);
  Echdir(subdir);

  char		buf[sizeof(pid_t) * 4 + 1];
  size_t	len = fmt_ulong(buf, pid);
  buf[len] = '\0';

  int		new_fd = Eopen(buf, O_WRONLY|O_CREAT|O_APPEND, 0600);
  Edup2(new_fd, fd);
  Eclose(new_fd);

  Echdir("..");
}

void
Logging_newProcess(char const *name)
{
  int		top_dir = Eopen("/", O_RDONLY, 0);
  int		cur_dir = Eopen(".", O_RDONLY, 0);
  
  Echroot(LOGDIR);
  Echdir("/");

  pid_t		pid = getpid();

  if (name==0) {
    WRITE_MSG(2, "Internal error: logging-name is NULL; assuming '@null'...\n");
    name = "@null";
  }
  
  // no error checking here; directory may exist already, but in error-case,
  // the next Echdir() will fail
  mkdir(name, 0700);
  Echdir(name);

  dupfd("out", pid, 1);
  dupfd("err", pid, 2);

  Efchdir(top_dir);
  Echroot(".");
  Eclose(top_dir);

  Efchdir(cur_dir);
  Eclose(cur_dir);
}

#else

static void
dupfd(char const *name, char const *ext, int fd)
{
  size_t	l1 = strlen(name);
  size_t	l2 = strlen(ext);
  char		buf[l1+l2+1];

  strcpy(buf,    name);
  strcpy(buf+l1, ext);

  int		new_fd = Eopen(buf, O_WRONLY|O_CREAT|O_APPEND, 0600);
  Edup2(new_fd, fd);
  Eclose(new_fd);
}

void
Logging_newProcess(char const *name)
{
  int		top_dir = Eopen("/", O_RDONLY, 0);
  int		cur_dir = Eopen(".", O_RDONLY, 0);
  
  Echroot(LOGDIR);
  Echdir("/");

  if (name==0) {
    WRITE_MSG(2, "Internal error: logging-name is NULL; assuming '@null'...\n");
    name = "@null";
  }

  dupfd(name, ".out", 1);
  dupfd(name, ".err", 2);

  
  pid_t		pid = getpid();
  char		buf[sizeof(pid)*4 + 1];
  size_t	len = fmt_long(buf, pid);

  Logging_timestamp(1);
  WRITE_MSG  (1, "===== starting process with pid ");
  (void)write(1, buf, len);
  WRITE_MSG  (1, " =====\n");

  
  Efchdir(top_dir);
  Echroot(".");
  Eclose(top_dir);

  Efchdir(cur_dir);
  Eclose(cur_dir);
}

#endif
